Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkMarchingSquares Class Reference

`#include <vtkMarchingSquares.h>`

Inheritance diagram for vtkMarchingSquares:

[legend]
Collaboration diagram for vtkMarchingSquares:

[legend]
List of all members.

## Detailed Description

generate isoline(s) from structured points set

Date:
  2002/08/30 21:05:16

Revision:
  1.40

vtkMarchingSquares is a filter that takes as input a structured points set and generates on output one or more isolines. One or more contour values must be specified to generate the isolines. Alternatively, you can specify a min/max scalar range and the number of contours to generate a series of evenly spaced contour values.

To generate contour lines the input data must be of topological dimension 2 (i.e., an image). If not, you can use the ImageRange ivar to select an image plane from an input volume. This avoids having to extract a plane first (using vtkExtractSubVolume). The filter deals with this by first trying to use the input data directly, and if not a 2D image, then uses the ImageRange ivar to reduce it to an image.

Warning:
  This filter is specialized to images. If you are interested in contouring other types of data, use the general vtkContourFilter.

See also:
  vtkContourFilter vtkMarchingCubes vtkSliceCubes vtkDividingCubes

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (63%)
  - Martin, Ken (9%)
  - Lorensen, Bill (7%)
  - Law, Charles (7%)

CVS logs (CVSweb):
  - .`h` (`/Patented/vtkMarchingSquares.h)`
  - .`cxx` (`/Patented/vtkMarchingSquares.cxx)`

Tests:
  vtkMarchingSquares (Tests)

Definition at line 83 of file vtkMarchingSquares.h.

## Public Types
typedef vtkPolyDataSource | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | SetValue (int i, float value)
void | GetValues (float *contourValues)
void | SetNumberOfContours (int number)
unsigned long int | GetMTime ()
void | SetLocator (vtkPointLocator *locator)
virtual vtkPointLocator * | GetLocator ()
void | CreateDefaultLocator ()
void | SetInput (vtkImageData *input)
vtkImageData * | GetInput ()
virtual void | SetImageRange (int data[])
virtual int * | GetImageRange ()
virtual void | GetImageRange (int data[6])
void | SetImageRange (int imin, int imax, int jmin, int jmax, int kmin, int kmax)
float | GetValue (int i)
float * | GetValues ()
int | GetNumberOfContours ()
void | GenerateValues (int numContours, float range[2])
void | GenerateValues (int numContours, float rangeStart, float rangeEnd)
## Static Public Methods
vtkMarchingSquares * | New ()
int | IsTypeOf (const char *type)
vtkMarchingSquares * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkMarchingSquares ()
| ~vtkMarchingSquares ()
void | Execute ()
## Protected Attributes
vtkContourValues * | ContourValues
int | ImageRange [6]
vtkPointLocator * | Locator

## Member Typedef Documentation

typedef vtkPolyDataSource vtkMarchingSquares::Superclass

| Reimplemented from vtkPolyDataSource. Definition at line 87 of file vtkMarchingSquares.h.

## Constructor & Destructor Documentation

vtkMarchingSquares::vtkMarchingSquares | ( |  | ) | `[protected]`

vtkMarchingSquares::~vtkMarchingSquares | ( |  | ) | `[protected]`

## Member Function Documentation

vtkMarchingSquares* vtkMarchingSquares::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkMarchingSquares::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkPolyDataSource.

int vtkMarchingSquares::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

virtual int vtkMarchingSquares::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkPolyDataSource.

vtkMarchingSquares* vtkMarchingSquares::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkPolyDataSource.

void vtkMarchingSquares::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkPolyDataSource.

void vtkMarchingSquares::SetInput | ( | vtkImageData * | input | ) |

| Set / get the input data or filter.

vtkImageData* vtkMarchingSquares::GetInput | ( |  | ) |

| Set / get the input data or filter.

virtual void vtkMarchingSquares::SetImageRange | ( | int | data[] | ) | `[virtual]`

| Set/Get the i-j-k index range which define a plane on which to generate contour lines. Using this ivar it is possible to input a 3D volume directly and then generate contour lines on one of the i-j-k planes, or a portion of a plane.

virtual int* vtkMarchingSquares::GetImageRange | ( |  | ) | `[virtual]`

| Set/Get the i-j-k index range which define a plane on which to generate contour lines. Using this ivar it is possible to input a 3D volume directly and then generate contour lines on one of the i-j-k planes, or a portion of a plane.

virtual void vtkMarchingSquares::GetImageRange | ( | int | data[6] | ) | `[virtual]`

| Set/Get the i-j-k index range which define a plane on which to generate contour lines. Using this ivar it is possible to input a 3D volume directly and then generate contour lines on one of the i-j-k planes, or a portion of a plane.

void vtkMarchingSquares::SetImageRange | ( | int | imin,
|  | int | imax,
|  | int | jmin,
|  | int | jmax,
|  | int | kmin,
|  | int | kmax
| ) |

| Set/Get the i-j-k index range which define a plane on which to generate contour lines. Using this ivar it is possible to input a 3D volume directly and then generate contour lines on one of the i-j-k planes, or a portion of a plane.

void vtkMarchingSquares::SetValue | ( | int | i,
|  | float | value
| ) | `[inline]`

| Set a particular contour value at contour number i. The index i ranges between 0<=i<NumberOfContours. Definition at line 143 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::SetValue().

float vtkMarchingSquares::GetValue | ( | int | i | ) | `[inline]`

| Get the ith contour value. Definition at line 148 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GetValue().

float * vtkMarchingSquares::GetValues | ( |  | ) | `[inline]`

| Get a pointer to an array of contour values. There will be GetNumberOfContours() values in the list. Definition at line 155 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GetValues().

void vtkMarchingSquares::GetValues | ( | float * | contourValues | ) | `[inline]`

| Fill a supplied list with contour values. There will be GetNumberOfContours() values in the list. Make sure you allocate enough memory to hold the list. Definition at line 162 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GetValues().

void vtkMarchingSquares::SetNumberOfContours | ( | int | number | ) | `[inline]`

| Set the number of contours to place into the list. You only really need to use this method to reduce list size. The method SetValue() will automatically increase list size as needed. Definition at line 168 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::SetNumberOfContours().

int vtkMarchingSquares::GetNumberOfContours | ( |  | ) | `[inline]`

| Get the number of contours in the list of contour values. Definition at line 173 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GetNumberOfContours().

void vtkMarchingSquares::GenerateValues | ( | int | numContours,
|  | float | range[2]
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 180 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GenerateValues().

void vtkMarchingSquares::GenerateValues | ( | int | numContours,
|  | float | rangeStart,
|  | float | rangeEnd
| ) | `[inline]`

| Generate numContours equally spaced contour values between specified range. Contour values will include min/max range values. Definition at line 187 of file vtkMarchingSquares.h. References ContourValues, and vtkContourValues::GenerateValues().

unsigned long int vtkMarchingSquares::GetMTime | ( |  | ) | `[virtual]`

| Return this object's modified time. Reimplemented from vtkObject.

void vtkMarchingSquares::SetLocator | ( | vtkPointLocator * | locator | ) |

virtual vtkPointLocator* vtkMarchingSquares::GetLocator | ( |  | ) | `[virtual]`

void vtkMarchingSquares::CreateDefaultLocator | ( |  | ) |

| Create default locator. Used to create one when none is specified. The locator is used to merge coincident points.

void vtkMarchingSquares::Execute | ( |  | ) | `[protected, virtual]`

| This method is the old style execute method Reimplemented from vtkSource.

## Member Data Documentation

vtkContourValues* vtkMarchingSquares::ContourValues`[protected]`

| Definition at line 133 of file vtkMarchingSquares.h. Referenced by GenerateValues(), GetNumberOfContours(), GetValue(), GetValues(), SetNumberOfContours(), and SetValue().

int vtkMarchingSquares::ImageRange[6]`[protected]`

| Definition at line 134 of file vtkMarchingSquares.h.

vtkPointLocator* vtkMarchingSquares::Locator`[protected]`

| Definition at line 135 of file vtkMarchingSquares.h.

The documentation for this class was generated from the following file:

- Patented/vtkMarchingSquares.h